# TOPOSUITE FOR ANDROID

<a href="https://scan.coverity.com/projects/2735">
  <img alt="Coverity Scan Build Status"
       src="https://scan.coverity.com/projects/2735/badge.svg"/>
</a>

Copyright(C) 2014, CRAG (Commission paritaire  Romande d'Apprentissage de
Géomaticien(ne)s)

TopoSuite for Android is an application developed by
[hgdev](http://www.hgdev.ch/) and commissioned by the CRAG (Commission paritaire
Romande d'Apprentissage de  Géomaticien(ne)s).

The application development is currently sponsored by the CRAG,
[CF-Geo](http://www.cf-geo.ch/), [CEPM](http://www.cepm.ch/),
[CPLN](http://www.cpln.ch/), [EPCA](http://www.epcasion.ch/) and
[Pro-Geo](http://www.pro-geo.ch/). If you are interested in seeing more features
or improvements in this application, please,
[contact us](http://www.hgdev.ch/contact.html).

This application is free software licensed under the GPLv2 license (see
LICENSE).  This means that you can freely use, study, redistribute and modify
this program.  You must, however, publish any changes to the source code and
make them available under the same license.

## ABOUT

TopoSuite for Android is an application that target devices running Android at
version 4.0.3 and later. It targets land surveyors by helping them determining
new geographical points based on measurements and offering some utilities.

It is able to do the following calculations:

* Polar calculations
    * station orientation
    * free station
    * polar survey
    * polar implantation
    * axis implantation
* Orthogonal calculations
    * orthogonal survey
    * orthogonal tracking
    * orthogonal implantation
* Intersections calculations
    * lines intersection
    * circles intersections
    * line / circle intersections
* Surfaces calculations
    * surface included with arc of a circle
    * parallel limit displacement regarding compulsory surface
* Miscellaneous
    * field / distance
    * point projection on a line
    * circle computation using three points
    * arc of a circle segmentation
* Mathematics
    * triangle solver
    * circular elements resolution

Data, such as points, may be imported into the application. The supported input
files are CSV (with ";" as a separator for now), LTOP and PTP. The list of
points can be exported to CSV and shared through e-mail, etc.

It is currently available in English and French (German planned).

## LIMITATIONS

This program has been developed in accordance with rules that are valid for land
surveying in Switzerland (angles are determined in gradian, lengths are in
meters and distance/surface results are rounded to the fourth decimal for
instance).

## CONTRIBUTING

Contributions are welcome. However, if your changes add a major feature, contact
us before because we might not want it into the application. Simple bug fixes or
minor improvements should usually be easily accepted.

## SPONSORING

This application is free but developers have to eat nonetheless. If you think
this piece of software is useful to you, feel free to contribute by making a
donation. If you feel like a feature is missing and you would like to have it
implemented, consider sponsoring the development of this feature. Several
organizations have already contributed to the development of this application.
Why not yours? Feel free to [contact us](http://www.hgdev.ch/contact.html)
about this.
